import MuseScore 3.0
import QtQuick 2.0

MuseScore {
    version: "1.0";
    description: "Converts Chord Symbols To Nashville numbers"
    menuPath: "Plugins.Harmony2Nash"

        id: replaceChordSyms

        Component.onCompleted: {
        if (mscoreMajorVersion >= 4) {
            replaceChordSyms.title = "Converts Chord Symbols To Nashville numbers"
        }
    }

    function findheadlen(harmony) {
        var str = harmony;
        var t = str.substr(1, 2);
        if ((t == "bb") || (t == "##")) {
            return 3;
        }
        t = str.substr(1, 1);
        if ((t == "b") || (t == "#")) {
            return 2;
        } else {
            return 1;
        }
    }


    function findhead(str) {
        var headlen = findheadlen(str);
        return str.substr(0, headlen);
    }
	
	function findCurKey(tick, keySigMap,keySigTicks){
		for (var j= 0; j < keySigTicks.length-1; j++){
			console.log ("tick keySigTicks[j] = " , tick  + " " + keySigTicks[j])
			if (tick >= keySigTicks[j] && tick < keySigTicks[j+1])
				return keySigMap[j]
		}
		return -1		
	}
	function findNashtail (tail){
		var tails = [
			["M",""],
			["Ma",""],
			["Maj",""],
			["ma",""],
			["maj",""],
			["t",""],
			["Madd9","2"],
			["Majadd9","2"],
			["majadd9","2"],
			["tadd9","2"],
			["Msus","4"],
			["Masus","4"],
			["Majsus","4"],
			["masus","4"],
			["majsus","4"],
			["tsus","4"],
			["M6","6"],
			["Ma6","6"],
			["Maj6","6"],
			["ma6","6"],
			["maj6","6"],
			["t6","6"],
			["M7","t7"],
			["Ma7","t7"],
			["Maj7","t7"],
			["ma7","t7"],
			["maj7","t7"],
			["t7","t7"],
			["M9","t9"],
			["Ma9","t9"],
			["Maj9","t9"],
			["ma9","t9"],
			["maj9","t9"],
			["t9","t9"],
			["m","-"],
			["mi","-"],
			["min","-"],
			["-","-"],
			["m6","-6"],
			["mi6","-6"],
			["min6","-6"],
			["-6","-6"],
			["m7","-7"],
			["mi7","-7"],
			["min7","-7"],
			["-7","-7"],
			["m9","-9"],
			["mi9","-9"],
			["min9","-9"],
			["-9","-9"],
			["dim","°"],
			["o","°"],
			["aug","+"],
			["+","+"],
			["sus","4"],
			["7","7"],
			["dom 7","7"],
			["dom 9","9"],
			["m7b5","ø"],
			["dim7","°7"],
			["dimMaj7","°t7"],
			["m7aug","m+7"],
			["m7#5","m+7"],
			["Maj7aug","+t7"],
			["Maj7#5","+t5"],
		];
		for (var j in tails)
			if(tail == tails[j][0]) return tails[j][1]
		return tail
	}
	function findNashHead (head, curKey){
		var sharphead = ["1", "#1", "2","#2", "3", "4","#4","5", "#5","6", "#6", "7"];
		var flathead = ["1", "b2", "2","b3", "3", "4","b5", "5", "b6","6", "b7", "7"];
		var nashlist = [
			["B#","C"],
			["C#","Db"],
			["D","D"],
			["D#","Eb"],
			["E","Fb"],
			["E#","F"],
			["F#","Gb"],
			["G","G"],
			["G#","Ab"],
			["A","A"],
			["A#","Bb"],
			["B","Cb"],
			["B#","C"],
			["C#","Db"],
			["D","D"],
			["D#","Eb"],
			["E","Fb"],
			["E#","F"],
			["F#","Gb"],
			["G","G"],
			["G#","Ab"],
			["A","A"],
			["A#","Bb"],
			["B","Cb"],
		];
		var flat = 1;
		var t = curKey.substr(1, 1);
        if (t == "b" || curKey == "F") flat = 1
		// flat = 0
		
		var i1
		var done = false
		var j = 0
		console.log ("nashlist.length = ",nashlist.length)
		while (done == false && j < nashlist.length){
			for (var i = 0; i < 2; i++){
				if (curKey == nashlist[j][i]){
					i1 = j
					console.log ("i1 = ",i1)
					done = true
					
				}
			}
			j++
		}
		done = false
		j = i1
		while (done == false && j < nashlist.length){
			for (var i = 0; i < 2; i++){
				if (head == nashlist[j][i]){
					console.log ("head found: j i1", j + " " + i1)
					if (flat == 0)
						return sharphead[j - i1]
					else
						return flathead[j - i1]
				}
			}
			j++
		}
		return head
	}
	
	function chordUCase(s){									
		var u = s.substr(0,1);								
		u = u.toUpperCase();								
		s = u + s.substr(1);								
		return s;								
	}
	function setCursorToTick(cursor, tick) {
		cursor.rewind(0);
		while (cursor.segment) {
			var curTick = cursor.tick;
			if (curTick >= tick) return true;
			cursor.next();
		}
		cursor.rewind(0);
		return false;
	}	


	
    function replaceChordSymbols() {
		var keySig = ["Cb","Gb","Db","Ab","Eb","Bb","F","","C","G","D","A","E","B","F#","C#"];
		var sig
		var keySigMap = []
		var keySigTicks = []
		
		var cursor = curScore.newCursor();
		cursor.rewind(0); // beginning of score									
		//var segment = curScore.firstSegment();
		
		while (cursor.segment) {
			if(cursor.keySignature >= 0)
				sig = keySig[cursor.keySignature + 8];
			else
				sig = keySig[cursor.keySignature + 7];
				
			keySigMap.push(sig)
			keySigTicks.push(cursor.tick)
			console.log("sig = ", sig + " " + cursor.tick)
			var oldtick = cursor.tick
			//cursor.nextMeasure()
			cursor.next()
		}
		// add dummy 
		keySigMap.push(sig)
		keySigTicks.push(oldtick + 480)
		
		cursor.rewind(0); // beginning of score									
		var segment = curScore.firstSegment();
		
        while (segment) {
            var aCount = 0;
            var annotation = segment.annotations[aCount];
			var found = false
            while (annotation && found == false) {
                if (annotation.type == Element.HARMONY) {
					found = true
                    var slashtail = "";
                    var harmony = annotation;
                    var str = harmony.text;
                    if (str != "") {
						console.log("str = ", str)
						console.log("segment.tick = ", segment.tick)
						var curKey = findCurKey(segment.tick, keySigMap,keySigTicks)
						console.log("curKey = ", curKey)
						if (curKey == -1)
							throw new Error("current keysig not found");
						// find slashtail
						//Am7/G in C becomes 6m/5
                        var slashtail = "";
                        var n = str.search("/");
                        if (n > -1) {
                            slashtail = str.substr(n+1);
							console.log ("249 slashtail = ", slashtail)  
							var slashlen = findheadlen(slashtail);
							var slashtail = slashtail.substr(0, slashlen)
							slashtail = chordUCase(slashtail)
							console.log ("252 slashtail = ", slashtail) 
                            str = str.substr(0, n);
                            console.log ("slashtail = ", slashtail)  
                            //console.log ("head = ", head)          
                        }
						var headlen = findheadlen(str);
						var head = str.substr(0, headlen)
						head = chordUCase(head)
						var tail = str.substr(headlen)
						console.log ("head = ", head)  
						console.log ("tail = ", tail) 
						var nashhead = findNashHead (head, curKey)
						console.log ("nashhead = ", nashhead) 
						var nashtail = findNashtail (tail)
						var nash = nashhead + nashtail
						console.log ("nash = ", nash) 
						
						if (slashtail != ""){
							console.log ("268 slashtail = ", slashtail + " " + curKey) 
							slashtail = findNashHead (slashtail, curKey)
							nash = nash + "/" + slashtail
						}
						//removeElement(annotation);
						//if (aCount == 1) throw new Error("message");
						var harmony = newElement(Element.HARMONY);
						harmony.harmonyType = HarmonyType.NASHVILLE
						harmony.placement = 0;
						harmony.text = nash
						setCursorToTick(cursor, segment.tick)
						//SetCursortoTick(segment.tick)
						cursor.add(harmony);
						//if (aCount == 1) throw new Error("message");
						
                    } // end if str
                } // end annotation.type == Element.HARMONY
                annotation = segment.annotations[++aCount];
            } // end while annotation   
            segment = segment.next;
        } // end while segment
		
    } // end function

    function smartQuit() {

        if (mscoreMajorVersion < 4) {
            Qt.quit()
        } else {
            quit()
        }
    } //smartQuit


    onRun: {
        if (typeof curScore === 'undefined') {
            smartQuit();
        }
        
        
		curScore.startCmd();
		replaceChordSymbols()
		curScore.endCmd();
	
        smartQuit()
    } // end onRun					
}